import { PrimaryButton, Icon, Dialog, DialogType, DialogFooter, DefaultButton } from '@fluentui/react';
import { createElement, Component } from 'react';
import { initializeFileTypeIcons, getFileTypeIconProps } from '@fluentui/react-file-type-icons';
import { SPHttpClient } from '@microsoft/sp-http';

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var totalNumberOfFile = 0;
var isFileUploadError = false;
var saveFilesToLibraryList = function saveFilesToLibraryList(files, listName, context, itemID, IsFileAsAttachment, destinationPath) {
  return new Promise(function (resolve, reject) {
    try {
      if (IsFileAsAttachment) {
        totalNumberOfFile = files.length - 1;
        savingFileToList(files, listName, context, itemID).then(function (result) {
          if (result) {
            Promise.resolve(result);
          } else {
            Promise.reject(result);
          }
        });
      } else {
        var requests = [];
        var file;

        if (files.length > 0) {
          for (var i = 0; i < files.length; i++) {
            file = files[i];
            requests.push(savingFilesToLibrary(file, context, destinationPath));
          }
        }

        Promise.all(requests).then(function (data) {
          resolve(data);
        })["catch"](function (ex) {
          reject("Error:" + ex);
        });
      }

      return Promise.resolve();
    } catch (e) {
      return Promise.reject(e);
    }
  });
};
var savingFileToList = function savingFileToList(files, listName, context, itemID) {
  try {
    return Promise.resolve(new Promise(function (resolve, reject) {
      try {
        debugger;

        var _temp2 = function () {
          if (totalNumberOfFile >= 0) {
            var file = files[totalNumberOfFile];
            var url = context.pageContext.web.absoluteUrl + ("/_api/web/lists/GetByTitle('" + listName + "')/Items(" + itemID + ")/AttachmentFiles/add(FileName='") + file.name + "')";
            var spOpts = {
              headers: {
                "Accept": "application/json",
                "Content-Type": "application/json"
              },
              body: file
            };
            return Promise.resolve(context.spHttpClient.post(url, SPHttpClient.configurations.v1, spOpts).then(function (response) {
              if (response.ok) {
                totalNumberOfFile = totalNumberOfFile - 1;
                savingFileToList(files, listName, context, itemID);
              }
            })["catch"](function (ex) {
              reject("Error:" + ex);
            })).then(function () {});
          } else if (isFileUploadError) {
            reject(false);
          } else {
            resolve(true);
          }
        }();

        return Promise.resolve(_temp2 && _temp2.then ? _temp2.then(function () {}) : void 0);
      } catch (e) {
        return Promise.reject(e);
      }
    }));
  } catch (e) {
    return Promise.reject(e);
  }
};
var savingFilesToLibrary = function savingFilesToLibrary(file, context, destinationPath) {
  try {
    return Promise.resolve(new Promise(function (resolve, reject) {
      try {
        debugger;
        var targetUrl = context.pageContext.web.serverRelativeUrl + "/" + destinationPath;
        var url = context.pageContext.web.absoluteUrl + "/_api/Web/GetFolderByServerRelativeUrl(@target)/Files/add(overwrite=true, url='" + file.name + "')?@target='" + targetUrl + "'&$expand=ListItemAllFields";
        var spOpts = {
          headers: {
            "Accept": "application/json",
            "Content-Type": "application/json"
          },
          body: file
        };
        return Promise.resolve(context.spHttpClient.post(url, SPHttpClient.configurations.v1, spOpts).then(function (response) {
          if (response.ok) {
            response.json().then(function (responseJSON) {
              if (responseJSON != null && responseJSON.value != null) {
                resolve(responseJSON.value);
              }
            });
          }
        })["catch"](function (ex) {
          reject("Error:" + ex);
        })).then(function () {});
      } catch (e) {
        return Promise.reject(e);
      }
    }));
  } catch (e) {
    return Promise.reject(e);
  }
};
var deleteFiles = function deleteFiles(context, files, listName, IsFileAsAttachment, itemID) {
  return new Promise(function (resolve, reject) {
    var requests = [];
    var file;
    var url;

    if (files.length > 0) {
      for (var i = 0; i < files.length; i++) {
        file = files[i];

        if (IsFileAsAttachment) {
          url = context.pageContext.web.webAbsoluteUrl + ("/_api/web/lists/GetByTitle('" + listName + "')/GetItemById(" + itemID + ")/AttachmentFiles/getByFileName('" + file.FileName + "')");
        } else {
          url = context.pageContext.web.webAbsoluteUrl + ("/_api/web/GetFileByServerRelativeUrl('" + file.ServerRelativeUrl + "')");
        }

        var spOpts = {
          headers: {
            "Accept": "application/json",
            "Content-Type": "application/json",
            'X-HTTP-Method': 'DELETE'
          }
        };
        requests.push(context.spHttpClient.post(url, SPHttpClient.configurations.v1, spOpts).then(function (response) {
          resolve(response.json());
        })["catch"](function (ex) {
          reject("Error:" + ex);
        }));
      }
    }

    Promise.all(requests).then(function (data) {
      resolve(data);
    })["catch"](function (ex) {
      reject("Error" + ex);
    });
  });
};
var dateValueAccess = function dateValueAccess(spDate) {
  var dt = new Date(spDate);
  return (dt.getDate() >= 10 ? dt.getDate() : "0" + dt.getDate()) + "-" + (dt.getMonth() > 8 ? dt.getMonth() + 1 : "0" + dt.getMonth() + 1) + "-" + dt.getFullYear() + ", " + (dt.getHours() > 9 ? dt.getHours() : "0" + dt.getHours()) + ":" + (dt.getMinutes() > 9 ? dt.getMinutes() : "0" + dt.getMinutes());
};

initializeFileTypeIcons(undefined);
var actionIconProps = {
  root: {
    padding: '5px'
  }
};

var AttachmentControl = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(AttachmentControl, _React$Component);

  function AttachmentControl(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.handleFileonChange = _this.handleFileonChange.bind(_assertThisInitialized(_this));
    _this.removeFiles = _this.removeFiles.bind(_assertThisInitialized(_this));
    _this.deleteFiles = _this.deleteFiles.bind(_assertThisInitialized(_this));
    _this.showHideDialog = _this.showHideDialog.bind(_assertThisInitialized(_this));
    _this.state = {
      filesTobeSave: [],
      fileToBeDeleted: [],
      hideDialog: true
    };
    return _this;
  }

  var _proto = AttachmentControl.prototype;

  _proto.handleFileonChange = function handleFileonChange(e) {
    var files = e.target.files;
    var temp = [];

    for (var i = 0; i < files.length; i++) {
      temp.push(files[i]);
    }

    temp = this.state.filesTobeSave.concat(temp);
    this.setState({
      filesTobeSave: temp
    });
    this.props.onChange(temp);
    this.fileRef.files = null;
  };

  _proto.removeFiles = function removeFiles(fileName) {
    var temp = this.state.filesTobeSave.filter(function (d) {
      return d.name != fileName;
    });
    this.setState({
      filesTobeSave: temp
    });
    this.props.onChange(temp);
  };

  _proto.deleteFiles = function deleteFiles(file) {
    var tempFileToBeDelete = this.state.fileToBeDeleted;
    tempFileToBeDelete.push(file);
    this.props.onDelete(tempFileToBeDelete);
  };

  _proto.showHideDialog = function showHideDialog(isHide, itemToBeAction) {
    this.setState({
      fileToBeDeleted: itemToBeAction,
      hideDialog: isHide
    });
  };

  _proto.getDocumentExtension = function getDocumentExtension(fileName) {
    return fileName.substring(fileName.lastIndexOf(".") + 1);
  };

  _proto.render = function render() {
    var _this2 = this;

    return createElement("div", null, createElement("input", {
      type: "file",
      id: "file",
      multiple: true,
      onChange: this.handleFileonChange,
      ref: function ref(r) {
        return _this2.fileRef = r;
      },
      style: {
        display: "none"
      }
    }), createElement(PrimaryButton, {
      style: {
        display: this.props.viewOnlyMode ? 'none' : ''
      },
      text: "Add Attachment",
      onClick: function onClick() {
        return _this2.fileRef.click();
      }
    }), createElement("div", {
      style: {
        padding: '5px'
      }
    }, this.state.filesTobeSave != undefined ? [].map.call(this.state.filesTobeSave, function (file) {
      return createElement("div", {
        style: {
          padding: '5',
          "float": 'left',
          marginRight: '5px'
        }
      }, createElement(PrimaryButton, {
        text: file.name
      }, createElement(Icon, {
        iconName: 'RemoveLinkX',
        onClick: function onClick() {
          return _this2.removeFiles(file.name);
        }
      })));
    }) : null), this.props.existingFiles != undefined ? [].map.call(this.props.existingFiles, function (item) {
      createElement("div", {
        style: {
          padding: '5',
          "float": 'left',
          marginRight: '5px'
        }
      }, createElement("div", null, createElement("td", null, createElement("div", null, item.Name != undefined ? item.Name : item.FileName), createElement(Icon, {
        role: 'button',
        styles: actionIconProps,
        iconName: 'Download',
        onClick: function onClick() {
          return window.open(_this2.props.context.pageContext.web.absoluteUrl + "/_layouts/15/download.aspx?SourceUrl=" + item.ServerRelativeUrl, "_self");
        }
      }), createElement(Icon, {
        hidden: _this2.props.viewOnlyMode,
        role: 'button',
        styles: actionIconProps,
        iconName: 'Delete',
        onClick: function onClick() {
          return _this2.deleteFiles(item);
        }
      }))), createElement(Icon, Object.assign({}, getFileTypeIconProps({
        extension: _this2.getDocumentExtension(item.Name != undefined ? item.Name : item.FileName),
        size: 16,
        imageFileType: 'png'
      }))), createElement("div", null, item.Name != undefined ? item.Name : item.FileName), createElement(Icon, {
        role: 'button',
        styles: actionIconProps,
        iconName: 'Download',
        onClick: function onClick() {
          return window.open(_this2.props.context.pageContext.web.absoluteUrl + "/_layouts/15/download.aspx?SourceUrl=" + item.ServerRelativeUrl, "_self");
        }
      }), createElement(Icon, {
        hidden: _this2.props.viewOnlyMode,
        role: 'button',
        styles: actionIconProps,
        iconName: 'Delete',
        onClick: function onClick() {
          return _this2.deleteFiles(item);
        }
      }));
    }) : null, createElement(Dialog, {
      hidden: this.state.hideDialog,
      onDismiss: function onDismiss() {
        return _this2.showHideDialog(true, undefined);
      },
      dialogContentProps: {
        type: DialogType.normal,
        title: "Delete file " + (this.state.fileToBeDeleted != undefined ? this.state.fileToBeDeleted.Name : "") + "?",
        closeButtonAriaLabel: 'Close'
      }
    }, createElement(DialogFooter, null, createElement(DefaultButton, {
      onClick: function onClick() {
        return _this2.showHideDialog(true, undefined);
      },
      text: "Don't Delete"
    }), createElement(PrimaryButton, {
      onClick: this.deleteFiles,
      text: "Yes,Delete"
    }))));
  };

  return AttachmentControl;
}(Component);

export default AttachmentControl;
export { dateValueAccess, deleteFiles, saveFilesToLibraryList, savingFileToList, savingFilesToLibrary };
//# sourceMappingURL=index.modern.js.map
